% lab08_ex_freq_response.m - frequency response of IIR digital filters
clear all; close all;

% Digital filter coefficients from program lab08_ex_filtering.m
bb = [ 1, 0, 2, 0, 1 ];
aa = [ 1.0000, -3.2199, 3.9203, -2.1387, 0.4412 ];

% [bb,aa] values were found by TF zeros & poles placement:
fs = 2000;   % sampling ratio
f1 = 50;     % frequency to be amplified
f2 = 500;    % frequency to be removed
p = 0.815*exp(j*2*pi*[f1 f1]/fs); p = [ p conj(p)];
a = poly(p);
z = exp(j*2*pi*[f2 f2]/fs); z = [ z conj(z)];
b = poly(z);
a_compare = [a' aa'], pause, b_compare = [b' bb'], pause  % comparison 

% Position of zeros & poles in respect to unitary circle
fi = 0  : pi/1000 : 2*pi; si=sin(fi); co=cos(fi);
figure; plot(co,si,'k-',real(z),imag(z),'bo',real(p),imag(p),'r*');
title('ZP'); pause

% IIR filter frequency response, magnitude and phase
f = 0 : 0.5 : fs/2;                 % frequencies of interest
zz = exp(j*2*pi*f/fs);              % eq.(8.41), zz - Z-transform variable
H1 = zz.^(length(a)-length(b)) .* polyval(b,zz) ./ polyval(a,zz);     % eq.(8.38)
H2 = polyval(b(end:-1:1),conj(zz)) ./ polyval(a(end:-1:1),conj(zz));  % eq.(8.37)
Hm = freqz(b,a,f,fs);               % Matlab function for IIR filter TF
error1 = max(H1-H2),                % error between H1 and H2
error2 = max(H1-Hm), pause          % error in comparison to Matlab

H = H1;
figure; plot( f, 20*log10(abs(H))); xlabel('f (Hz)'); title('|H(f)| (dB)'); grid; pause
figure; plot( f, unwrap(angle(H))); xlabel('f (Hz)'); title('angle |H(f)| (rad)'); grid; pause
